prov_Units <- function(recipe, data, orig_units) {

  #NEW UNITS (Recipe)
  user_units <- recipe$Analysis$Variables$name
  var.freq <- recipe$Analysis$Variables$freq 

  #?? Then the idea is to add this information in the UnitConvesrsion entity
  #ORIGINAL UNITS (Data units)
  org_fcst <- orig_units[1]
  orig_hcst <- orig_units[2]
  orig_obs <- orig_units[3]

  graph <- data$graph.prov
  parentnodenames <- graph$parentnodename

  graph <- graph$graph
  
  unitconversion.nodename <- paste0("UnitConversion")

  graph <- add_vertices_sunset(graph,
                                nv = 1,
                                name = unitconversion.nodename,
                                label = "Unit conversion",
                                className = "ds:UnitConversion",
                                )

  for (name in parentnodenames) { 
    graph <- add_edges(graph,
                     c(getNodeIndexbyName(graph, name),
                         getNodeIndexbyName(graph, unitconversion.nodename)),
                       label = "ds:hadDerivation")
}

  #Command Call and output definition
  if (!is.null(data$fcst)) {
    graph <- prov_Command(graph, package = "Units",
                                version = "2.0.0",
                                fun = "modules/Units/Units.R",
                                arg.list =
                                  list("Recipe",
                                       "Data"),
                                origin.node.name =
                                  c(parentnodenames[1],
                                    parentnodenames[2],
                                    parentnodenames[3]))
    graph <- list("graph" = graph,
                  "parentnodename"
                  = list("parentnodename_fcst"
                         = parentnodenames[1],
                         "parentnodename_hcst"
                         = parentnodenames[2],
                         "parentnodename_obs"
                         = parentnodenames[3]))
  } else {
    graph <- prov_Command(graph, package = "Units",
                                version = "2.0.0",
                                fun = "modules/Units/Units.R",
                                arg.list =
                                  list(
                                       "Recipe",
                                       "Data"),
                                origin.node.name =
                                  list(parentnodenames[1],
                                       parentnodenames[2]))
    graph <- list("graph" = graph,
                  "parentnodename"
                  = list("parentnodename_hcst"=parentnodenames[1],
                         "parentnodename_obs"=parentnodenames[2]))
  }

  message("INFO  ", "[", Sys.time(), "]",
          " Provenance correctly generated for the Units module")

  #Name of the generated JSON according to recipe values
  main_dir <- paste0(recipe$Run$output_dir, "/outputs", "/provenance/")
  recipe_model <- paste0("sys-",
                         gsub('\\.', '', recipe$Analysis$Datasets$System$name))
  recipe_split <- paste0("_ref-", recipe$Analysis$Datasets$Reference$name,
                         "_var-", recipe$Analysis$Variables$name,
                         "_reg-", recipe$Analysis$Region$name,
                         "_sdate-", recipe$Analysis$Time$sdate)

  json_name <- paste0("main_provenance", "_", recipe_model, recipe_split)

  #Convert from igraph to JSON format and store in the output directory
  graph2json(graph$graph, output.file = paste0(main_dir,
                                               json_name,  ".json"))

  return(graph)

}
